<template>
  <div>
    <a v-on:click="logout" href="#">Odhlásit se</a>
    <router-link to="/edit-ms-credentials">Upravit memsource údaje</router-link>
    <h2>Projects</h2>
    <span v-if="loading">Loading...</span>
    <div v-if="!loading">
      <table>
        <thead>
          <tr>
            <th v-for="col in cols" v-bind:key="col">{{col}}</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="project in projects" v-bind:key="project.name">
            <td>{{project[0]}}</td>
            <td>{{project[1]}}</td>
            <td>{{project[2]}}</td>
            <td>{{project[3]}}</td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
</template>

<script>
import AuthService from '../../services/auth'
import withMemsourceCredentials from '../../services/memsource-credentials'

export default {
  name: 'projects',
  data () {
    return {
      loading: true,
      error: false,
      projects: null,
      cols: ['Name', 'Status', 'Source language', 'Target languages']
    }
  },
  methods: {
    logout: function () {
      AuthService.logout()
      this.$router.push('login')
    },
    load: function () {
      const requestOptions = {
        method: 'GET',
        headers: {
          'Content-Type': 'application/json'
        }
      }

      return fetch('https://cloud.memsource.com/web/api2/v1/projects?token=' + localStorage.getItem('memsource-api-token'), requestOptions)
        .then(response => response.json())
        .then(responseData => {
          this.projects = responseData.content.map(project => [project.name, project.status, project.sourceLang, project.targetLangs.join(', ')])
          this.loading = false
        })
    }
  },
  created () {
    if (localStorage.getItem('memsource-api-token') == null) {
      withMemsourceCredentials(AuthService.memsourceApiLogin, this.load)
    } else {
      this.load()
    }
  }
}
</script>
